
public class TestPassByValue { // java TestPassByValue

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		char i=0;
		
		Product p = new Product();
		p.setPrice(100);
		System.out.println(p.getPrice());//100
		
		ProductService service = new ProductService();
		service.addPrice(p.getPrice());
		System.out.println(p.getPrice()); //100
		
		service.addPrice(p);
		System.out.println(p.getPrice()); //110
	}

}

//UML, Robustness analysis
class Product{
	private double price;

	public double getPrice() {
		return price;
	}

	public void setPrice(double price) {
		this.price = price;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		long temp;
		temp = Double.doubleToLongBits(price);
		result = prime * result + (int) (temp ^ (temp >>> 32));
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (this.getClass() != obj.getClass())
			return false;
		Product other = (Product) obj;
		
		if (Double.doubleToLongBits(price) != Double
				.doubleToLongBits(other.price))
			return false;
		return true;
	}
	
	
	
}

class ProductService{
	
	public void addPrice(double price){
		price+=10;  //price = (double)(price+10)
	}
	
	public void addPrice(Product p){
		p.setPrice(p.getPrice()+10);
	}	
	
	
}